#include "http.h"
#include "picohttpparser.h"

/*
 * given the HTTP path, parse the request
 */
http_parse_error http_parse_request(http_request *req, const char *buf, size_t buf_size) {
  // First we try to parse the incoming HTTP request
  const char *method, *path;
  struct phr_header headers[16];
  size_t method_len, path_len, num_headers;
  int minor_version;

  int res = phr_parse_request(buf, buf_size,
                              &method, &method_len, &path, &path_len,
                              &minor_version, headers, &num_headers, 0);

  if (res == -2) {
    return http_parse_error_incomplete;
  } else if (res < 0) {
    return http_parse_error_invalid;
  }

  // Next, we parse the HTTP request as a lander-specific request
  if (path_len == 0 || path[0] != '/') {
    return http_parse_error_invalid;
  }

  return http_parse_error_ok;
}
